YayMounts = LibStub("AceAddon-3.0"):NewAddon("YayMounts","AceConsole-3.0", "AceEvent-3.0")
AceGUI = LibStub("AceGUI-3.0")

local function pairsByKeys (t, f)
  local a = {}
    for n in pairs(t) do 
      table.insert(a, n) 
    end
    table.sort(a, f)
    local i = 0      -- iterator variable
    local iter = function ()   -- iterator function
      i = i + 1
      if a[i] == nil then 
        return nil
      else 
        return a[i], t[a[i]]
      end
    end
  return iter
end

local options = {
  name="YayMounts",
  handler = YayMounts,
  type = "group",
  args = {
    enable = {
      type = "execute",
      name = YayMountsLocale.Misc.optionsGUIButton,
      func = "Frames",
    },
  }
}

YayMountsState = {
	playerFaction = nil, 
	usePassengerMount = false, 
	forceRepairMount = false,
	localClass = nil,
	class = nil,
	playerCombat = false
}

YayMountsDB = {
	tProfiles, tProfiles2
}

YMSpellIDs = {
	["MONK"] = 109132, -- Roll
	["PALADIN"] = 190784, -- Divine Steed
	["DEATHKNIGHT"]= 212552, -- Wraith Walk
	["SHAMAN"] = 2645, -- Ghost Wolf
	["ROGUE"] = 2983, -- Sprint
}

local t, unsortedTable, p = {}, {}
local currentTab, currentSubTab
local f = CreateFrame("frame")
local f2 = CreateFrame("frame")

local defaults = { 
  global = { 
    ["CV"] = 1.0, --Current version
  },
  profile = {
    settings = {
      ["ER"] = true, --emptyrandom: use random mount if none selected
      ["FFP"] = false, --Druid: Use flight form with priority
      ["TTT"] = false, --Travel to Travel, no human form. Mostly for pvp.
      ["MTFF"] = false, --Druid: When flying mounted shift directly to flight form
      ["FBP"] = false, --Prioritize flying broom, even over Flight form
      ["HM"] = false, -- Has Mount
      ["NDWF"] = false, -- No Dismount while Flying. Safe!
      ["FFM"] = true, --Force Flying Mount (in ground areas)
      ["DEATHKNIGHT"] = true, --DeathKnight: Wraith Walk
	  ["PALADIN"] = true, --Paladin: Divine Steed
	  ["SHAMAN"] = true, --Shaman: Ghost wolf
	  ["MONK"] = true, --Monk: Roll
      ["ROGUE"] = true, --Rogue: Sprint
      ["PRIEST"] = true, --Priest/Mage: Levitate/Slowfall
	  ["MAGE"] = true, --Priest/Mage: Levitate/Slowfall
      ["URM"] = true, --use a repair mount if one exists
	  ["TELAARI"] = true, --Use the Telaari Talbuk (or horde equivalent) in Nagrand
	  ["ENABLENEW"] = true, -- New mounts are selected upon learning them
    },
    misc = {
      ["DBSize"] = 0, -- Database size
      ["MinDurability"] = 0.2, --summon repair mount if under X durability
      
      RepairMounts = {},
      NumMounts = {
        ["Total"] = 0,
        ["Ground"] = 0,
        ["Flying"] = 0,
		["Profession"] = 0,
        ["Special"] = 0,
        },
    },    
    mounts = {
      ['*'] = {
      },
    },
  }
}

function YayMounts:OnInitialize() 
  self.db = LibStub("AceDB-3.0"):New("YayMountsDB", defaults, "Default")
  local ymOptions = LibStub("AceConfigRegistry-3.0")
  ymOptions:RegisterOptionsTable("YayMounts",options)
  self.ymOpFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("YayMounts","YayMounts")
  self:RegisterChatCommand("ym", "ChatCommand")
  self:RegisterChatCommand("yaymounts", "ChatCommand")
end

function YayMounts:ChatCommand(input) --Chat command function
  if input == "reload" or input == "rl" then
    YayMounts:ReSort()
    self:Print(YayMountsLocale.Misc.mountsReloaded)
  
  else
    YayMounts:Frames("tab1")
  end
end

function YayMounts:OnEnable()-- addon enabled
	YayMountsState.localClass, YayMountsState.class = UnitClass("player")
	YayMountsDB.tProfiles = {}
	YayMountsDB.tProfiles2 = {}
	
	YayMounts:AlphaSortProfileDB()

	local _, race = UnitRace("player")
    
	--if self.db.global["CV"] ~= version then
		--self.db.global["CV"] = version
		YayMounts:ReSort()
	--end

	YayMounts:MapOverrides()
  
	-- Register events
	self:RegisterEvent("UPDATE_BINDINGS", "MapOverrides")
	self:RegisterEvent("COMPANION_LEARNED", "EventHandler")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "EventHandler")
	YayMounts:RegisterEvent("PLAYER_REGEN_DISABLED", "EventHandler")
	YayMounts:RegisterEvent("PLAYER_REGEN_ENABLED", "EventHandler")

	--if race == "Worgen" and UnitLevel("player") < 21 then
		--self:RegisterEvent("PLAYER_LEVEL_UP", "EventHandler")
	--end
end

function YayMounts:EventHandler(arg1, arg2)
  if arg1 == "PLAYER_REGEN_DISABLED" then
    YayMountsState.playerCombat = true
		
    if YayMountsState.class == "DRUID" then
		if not self.db.profile.settings["TTT"] then
			YayMounts:SetMacroButtonCombat("[swimming] "..YayMounts:SpellToName(783).."; [outdoors] "..YayMounts:SpellToName(783).."; "..YayMounts:SpellToName(768))
		else
			YayMounts:SetMacroButtonCombat("[swimming] !"..YayMounts:SpellToName(783).."; [outdoors] !"..YayMounts:SpellToName(783).."; !"..YayMounts:SpellToName(768))
		end
      
    elseif YayMountsState.class == "PRIEST" then
		if IsUsableSpell(1706) and self.db.profile.settings["PRIEST"] then --IsUsableSpell checks for reagents/glyphs
			YayMounts:SetMacroButtonCombat("[@player] "..YayMounts:SpellToName(1706).."\n/cancelaura "..YayMounts:SpellToName(1706)) --Levitate
		end
      
    elseif YayMountsState.class == "MAGE" then
		if IsUsableSpell(130) and self.db.profile.settings["MAGE"] then
			YayMounts:SetMacroButtonCombat("[@player] "..YayMounts:SpellToName(130).."\n/cancelaura "..YayMounts:SpellToName(130)) --Slow fall
		end
    
    elseif self.db.profile.settings[YayMountsState.class] then
		YayMounts:SetMacroButtonCombat(YayMounts:SpellToName(YMSpellIDs[YayMountsState.class]))
    end
    
  elseif arg1 == "PLAYER_REGEN_ENABLED" then
    YayMountsState.playerCombat = false
    YayMounts:SetMacroButton()
    
  elseif arg1 == "PLAYER_LEVEL_UP" then
    if arg2 == 20 then
      YayMounts:ReSort()
      self:UnregisterEvent("PLAYER_LEVEL_UP")
    end
    
  elseif arg1 == "COMPANION_LEARNED" then
    YayMounts:ReSort()
	YayMounts:HandleNewCompanion()
    
  elseif arg1 == "PLAYER_ENTERING_WORLD" then
    local faction, _ = UnitFactionGroup("player")
    if(faction == "Alliance") then
      YayMountsState.playerFaction = 1
    elseif(faction == "Horde") then
      YayMountsState.playerFaction = 0
    else
      self:Print("Unrecognized faction: ", faction)
      YayMountsState.playerFaction = -1
    end
    self:UnregisterEvent("PLAYER_ENTERING_WORLD")
  end
end

--------------------------------------------------------------
--database handling and creation functions
--------------------------------------------------------------

function YayMounts:IsUsableMount(id)
	local n,spellID,_,_,isUsable,_,_,_,_,isHidden,isCollected = C_MountJournal.GetMountInfoByID(id)
	return isUsable
end

function YayMounts:AlphaSortProfileDB()
  table.wipe(YayMountsDB.tProfiles)
  table.wipe(YayMountsDB.tProfiles2)
  
  self.db:GetProfiles(YayMountsDB.tProfiles)

  for k, v in pairs(YayMountsDB.tProfiles) do
    YayMountsDB.tProfiles2[v] = k     --put names as key, order #'s as value
  end
  
  table.wipe(YayMountsDB.tProfiles)
  
  for k, v in pairsByKeys(YayMountsDB.tProfiles2) do
    tinsert(YayMountsDB.tProfiles, k)   --sort alphabetically, name as value
  end
  
end

function YayMounts:ReSort()
  local tempTable = {}
  
  for k,v in pairs(self.db.profile.mounts) do
    tempTable[k] = self.db.profile.mounts[k][1]
  end
  table.wipe(self.db.profile.mounts)
  
  YayMounts:ReloadMounts(tempTable)
end

function YayMounts:ProfessionCheck(spellID)
	if YayMountsType["Professions"][spellID] then
		local prof1, prof2, _,_,_,_ = GetProfessions()
		local SL1, SL2

		if prof1 then
			prof1, _, SL1 = GetProfessionInfo(prof1)

			if YayMountsType["Professions"][spellID][1] == prof1 then
				if YayMountsType["Professions"][spellID][2] <= SL1 then
					return true
				end
			end
		end

		if prof2 then
			prof2, _, SL2 = GetProfessionInfo(prof2)

			if YayMountsType["Professions"][spellID][1] == prof2 then
				if YayMountsType["Professions"][spellID][2] <= SL2 then 
				  return true
				end
			end
		end

		return false
	end

	return true
end

function YayMounts:ReputationCheck(spellID)
  if YayMountsType["Reputation"][spellID] then    
	-- Nothing gated behind reputation right now
    return false
  end
  
  return true -- Not a known reputation restricted spell
end

function YayMounts:SpellToName(spell) --converts spell ID to Name
  local name = GetSpellInfo(spell)
  return name
end

function YayMounts:ItemToName(itemID) --converts spell ID to Name
  local name = GetItemInfo(itemID)
  return name
end

function YayMounts:GetDbValue(info, key)
  if info == "mounts" then
    return self.db.profile.mounts[key][1]
  
  elseif info == "settings" then
    return self.db.profile.settings[key]
    
  elseif info == "misc" then
    return self.db.profile.misc[key]
  end
end

function YayMounts:SetDbValue(info, key, state)
  if info == "mounts" then
    self.db.profile.mounts[key][1] = state
  elseif info == "misc" then
    self.db.profile.misc[key] = state  
  elseif info == "settings" then
    self.db.profile.settings[key] = state
  end
end

function YayMounts:ClearMounts(mountType)-- clear all mounts
	if mountType == "prof" then
		for spellID,v in pairs(YayMounts.db.profile.mounts) do
			if t[spellID] ~= nil and YayMountsType["Professions"][spellID] ~= nil then
				YayMounts.db.profile.mounts[spellID][1] = false
				t[spellID]:SetValue(false)
			end
		end
		
		return
	end

	for spellID,v in pairs(self.db.profile.mounts) do
		if self.db.profile.mounts[spellID][2] == mountType and t[spellID] ~= nil then
			if YayMounts:ProfessionCheck(spellID) then
				self.db.profile.mounts[spellID][1] = false
				t[spellID]:SetValue(false)
			end
		end
	end
end

function YayMounts:SelectAllMounts(mountType)-- select all mounts
	if mountType == "prof" then
		for spellID,v in pairs(YayMounts.db.profile.mounts) do
			if t[spellID] ~= nil and YayMountsType["Professions"][spellID] ~= nil then
				YayMounts.db.profile.mounts[spellID][1] = true
				t[spellID]:SetValue(true)
			end
		end
		
		return
	end

	for spellID,v in pairs(self.db.profile.mounts) do
		if self.db.profile.mounts[spellID][2] == mountType and t[spellID] ~= nil then
			if YayMounts:ProfessionCheck(spellID) then
				self.db.profile.mounts[spellID][1] = true
				t[spellID]:SetValue(true)
			end
		end
	end
end

local function BuildListSortFunc(a, b)
    return a.name < b.name
end

function YayMounts:BuildList(mountType)--Builds and draws the checkboxes for the opened tab
	unsortedTable = {}
	for index,id in pairs(C_MountJournal.GetMountIDs()) do
		local name,spellID,icon,_,_,_,_,_,faction,_,_ = C_MountJournal.GetMountInfoByID(id)
		
		unsortedTable[index] = {}
		unsortedTable[index].id = id
		unsortedTable[index].name = name
		unsortedTable[index].spellID = spellID
		unsortedTable[index].icon = icon
		unsortedTable[index].faction = faction
	end
	
	table.sort(unsortedTable, BuildListSortFunc)

	t = {}
	for index,_ in pairs(unsortedTable) do	
		local mount = unsortedTable[index]
		if mount.faction == nil or mount.faction == YayMountsState.playerFaction then
			if self.db.profile.mounts[mount.spellID][2] == mountType then
				t[mount.spellID] = AceGUI:Create("CheckBox")
				t[mount.spellID]:SetImage(mount.icon)
				t[mount.spellID]:SetLabel(mount.name)
				t[mount.spellID]:SetValue(YayMounts:GetDbValue("mounts", mount.spellID))
				t[mount.spellID]:SetCallback("OnValueChanged",  
					function() 
						YayMounts:SetDbValue("mounts", mount.spellID, t[mount.spellID]:GetValue()) 
					end)
				YayMountsContent:AddChild(t[mount.spellID])
			end
		end
	end
	
	collectgarbage()
end

function YayMounts:ReloadMounts(tempTable)--Rebuilds the database. Activates on load
	self.db.profile.misc.NumMounts["Ground"] = 0
	self.db.profile.misc.NumMounts["Flying"] = 0
	self.db.profile.misc.NumMounts["Profession"] = 0
	self.db.profile.misc.NumMounts["Special"] = 0
	self.db.profile.misc.NumMounts["Total"] = 0
  
	for index,id in pairs(C_MountJournal.GetMountIDs()) do
		local n,spellID,_,_,_,isUsable,_,_,_,isHidden,isCollected = C_MountJournal.GetMountInfoByID(id)
		local _, _, _, _, mountTypeID = C_MountJournal.GetMountInfoExtraByID(id)
		
		-- Deal with class mounts not showing up as collected on other classes.
		if(YayMountsType["Class"][spellID] ~= nil) then
			if(tempTable[spellID] ~= nil) then
				isCollected = true
			end
		end
		
		if(isCollected and mountTypeID ~= 242) then
			local mountType = YayMountsType["Mounts"][mountTypeID]
			if(YayMountsType["Professions"][spellID] ~= nil) then
				mountType = "profession"
			end
		  
		  
			if(mountType ~= nil) then
				--Check if we have a repair mount
				if spellID == 61425 or spellID == 61447 or spellID == 122708 then
					self.db.profile.misc.RepairMounts[spellID] = true
				end

				if mountType == nil and spellID ~= 75207 then --Found a 'new' mount, ie unknown type
					self.db.profile.misc.NumMounts["Total"] = self.db.profile.misc.NumMounts["Total"] - 1
				else
					-- Keep old selection setting
					if tempTable[spellID] == nil then
						self.db.profile.mounts[spellID] = {self.db.profile.settings["ENABLENEW"], mountType, id}
					else
						self.db.profile.mounts[spellID] = {tempTable[spellID], mountType, id}
					end
				end

				--Increment the counters
				if mountType == "ground" then
					self.db.profile.misc.NumMounts["Ground"] = self.db.profile.misc.NumMounts["Ground"] + 1
				elseif mountType == "fly" then
					self.db.profile.misc.NumMounts["Flying"] = self.db.profile.misc.NumMounts["Flying"] + 1
				elseif mountType == "special" then
					self.db.profile.misc.NumMounts["Special"] = self.db.profile.misc.NumMounts["Special"] + 1
				elseif mountType == "profession" then
					self.db.profile.misc.NumMounts["Profession"] = self.db.profile.misc.NumMounts["Profession"] + 1
				end

				self.db.profile.misc.NumMounts["Total"] = self.db.profile.misc.NumMounts["Total"] + 1
			end
		end
	end
  
	if self.db.profile.misc.NumMounts["Total"] > 0 then
		self.db.profile.settings["HM"] = true
	end
  
	--self:Print("Loaded", self.db.profile.misc.NumMounts["Total"], "mounts.")
end

--------------------------------------------------------------
--Keybinding stuff
--------------------------------------------------------------
function YayMounts:UpdateBindingButtons(btn1, btn2, btn3, btn4)
	btn1:SetKey(GetBindingKey("YAYMOUNTBINDING"))
	btn2:SetKey(GetBindingKey("YAYMOUNTBINDING2"))
	btn3:SetKey(GetBindingKey("YAYMOUNTBINDING3"))
	btn4:SetKey(GetBindingKey("YAYMOUNTBINDING4"))
end

function YayMounts:MapOverrides()
  if not InCombatLockdown() then
    ClearOverrideBindings(YayMountsButton)
    local key1 = GetBindingKey("YAYMOUNTBINDING")
    if key1 then
      SetOverrideBindingClick(YayMountsButton, true, key1, YayMountsButton:GetName())
    end

    ClearOverrideBindings(YayMountsButton2)
    key1 = GetBindingKey("YAYMOUNTBINDING2")
    if key1 then
      SetOverrideBindingClick(YayMountsButton2, true, key1, YayMountsButton2:GetName())
    end
    
    ClearOverrideBindings(YayMountsButton3)
    key1 = GetBindingKey("YAYMOUNTBINDING3")
    if key1 then
      SetOverrideBindingClick(YayMountsButton3, true, key1, YayMountsButton3:GetName())
    end
	
	ClearOverrideBindings(YayMountsButton4)
    key1 = GetBindingKey("YAYMOUNTBINDING4")
    if key1 then
      SetOverrideBindingClick(YayMountsButton4, true, key1, YayMountsButton4:GetName())
    end
  end
end

function YayMounts:Keybinding(key, buttonID)
	if not key then
		key = ""
	end

	--if not InCombatLockdown() then
		if buttonID == 1 then
			local key1 = GetBindingKey("YAYMOUNTBINDING")
			if key1 then
				SetBinding(key1)
			end
			SetBinding(key, "YAYMOUNTBINDING")
		  
		elseif buttonID == 2 then
			local key1 = GetBindingKey("YAYMOUNTBINDING2")
			if key1 then
				SetBinding(key1)
			end
			SetBinding(key, "YAYMOUNTBINDING2")
		
		elseif buttonID == 3 then
			local key1 = GetBindingKey("YAYMOUNTBINDING3")
			if key1 then
				SetBinding(key1)
			end
			SetBinding(key, "YAYMOUNTBINDING3")
		
		elseif buttonID == 4 then
			local key1 = GetBindingKey("YAYMOUNTBINDING4")
			if key1 then
				SetBinding(key1)
			end
			SetBinding(key, "YAYMOUNTBINDING4")
		end
	--end
  
	SaveBindings(GetCurrentBindingSet())
end